/* oooooooooooooooooooooooooooooooooo */
/* Copyright (C) 1991   P. Gburzynski */
/* oooooooooooooooooooooooooooooooooo */

/* --- */

/* ------------------------------------------------------------- */
/* SMURPH version of the C++ library (the minimum needed subset) */
/* ------------------------------------------------------------- */

#define	OBUFSIZE  256		// Size of an ostream buffer

#if	ZZ_ATT

#include	<math.h>
#include	<string.h>
#include	<libc.h>
#include	<osfcn.h>
extern "C" {
#if	ZZ_ATT_SUN
char	*sprintf (char*, const char*, ...);
#else
int	sprintf (char*, const char*, ...);
#endif
}

#else

extern "C" {

double  ceil(double);
double  cos(double);
double  exp(double);
double  fabs(double);
double  floor(double);
double  log(double);
double  log10(double);
double  pow(double, double);
double  sin(double);
double  sqrt(double);
double  tan(double);

long	atol (const char*);
int	atoi (const char*);
double	atof (const char*);

void volatile exit (int);
int	strlen (const char*);
char*	strcpy (char*, const char*);
char*	strncpy (char*, const char*, int);
char*	strcat (char*, const char*);
int	strcmp (const char*, const char*);
int	strncmp (const char*, const char*, int);
int	read (int, void*, unsigned);
int	write (int, const void*, unsigned);
int	open (const char*, int, ...);
int	close (int);
void	perror (const char*);
int	socket (int, int, int);
void	bcopy (const void*, void*, int);
void	bzero (void*, int);
unsigned  sleep (unsigned);
char	*sprintf (char*, const char*, ...);
}

#endif

typedef	void(*ZZ_EHTYPE)(char*);

void	set_File_error_handler (ZZ_EHTYPE);

#ifndef	NULL
#define	NULL 0
#endif

char *form (const char*, ...);

#ifndef HUGE
#if defined(sun) || defined(hp300) || defined(hpux) || defined(m88k) || defined(sony)
#define HUGE	   1.79769313486231470e+308
#endif
#if defined(sequent)
extern double _maxdouble;
#define HUGE  _maxdouble
#endif
#if defined(i386)
#define HUGE	   1.79769313486231570e+308
#endif
#if defined(convex)
#define HUGE	   8.9884656743115785e+306
#endif 
#ifndef	HUGE					// If none of the above use ...
#define HUGE	   1.701411834604692293e+38	// a conservative estimate
#endif
#endif

class	istream {

	private:

	int   fd, end, ungp;
	char  ung [8];
	int   digg (char*, int&);

	public:

	istream (char*, char*);
	istream (int);
	int readable ();
	void get (char&);
	void putback (char);
	void close ();
	int eof ();
	friend istream &operator >> (istream&, int&);
	friend istream &operator >> (istream&, long&);
	friend istream &operator >> (istream&, float&);
	friend istream &operator >> (istream&, double&);
	friend istream &operator >> (istream&, char&);
};

istream &operator >> (istream&, int&);
istream &operator >> (istream&, long&);
istream &operator >> (istream&, float&);
istream &operator >> (istream&, double&);
istream &operator >> (istream&, char&);

class	ostream {

	private:

	int	fd;
	char	buf [OBUFSIZE]; int bp;

	public:
	ostream (char*, char*);
	ostream (int);
	~ostream ();
	void put (char);
	void close ();
	void flush ();
	friend ostream &operator << (ostream&, long);
	friend ostream &operator << (ostream&, int);
	friend ostream &operator << (ostream&, char);
	friend ostream &operator << (ostream&, double);
	friend ostream &operator << (ostream&, char*);
};

ostream &operator << (ostream&, long);
ostream &operator << (ostream&, int);
ostream &operator << (ostream&, char);
ostream &operator << (ostream&, double);
ostream &operator << (ostream&, char*);

extern	istream cin;
extern  ostream cout, cerr;
