/* oooooooooooooooooooooooooooooooooo */
/* Copyright (C) 1991   P. Gburzynski */
/* oooooooooooooooooooooooooooooooooo */

/* --- */


/* #define      cdebug(s) write (2, s, strlen (s)) */
#define cdebug(s)

/* ---------------- */
/* System interface */
/* ---------------- */

#ifdef  sgi
#define SYSV
#endif

/*      Already included by times.h
#include                <sys/types.h>
*/

#define         USG     // To bypass a bug in C++ time.h
#include                <sys/times.h>
#undef          USG
#include                <signal.h>
#define         KERNEL  // Bypasses a bugoid in Sun4 includes
#include                <sys/file.h>
#undef          KERNEL
#include                <sys/param.h>
#include                <setjmp.h>

/* ------------------- */
/* Checkpoint includes */
/* ------------------- */

#ifdef  mips

#ifdef  SYSV
#ifndef sgi
#include        <sys/immu.h>            // These assholes made it impossible
					// to use this file on SGI
#else
#define USRDATA         0x10000000
#define USERSTACK       0x7ffff000
#endif
#define USRSTACK        USERSTACK       // Different name for SYSV
#ifndef L_XTND
#define L_XTND          2               // May be undefined in SYSV
#endif
#else
#include        <sys/exec.h>
#ifndef USRSTACK
#include        <machine/vmparam.h>     // For the tandem version
#endif
#endif

#else

#include        <a.out.h>

#endif

#ifndef mips
#include        <sys/vmparam.h>
#endif

#include        <string.h>

#undef          DELAY
#undef          atob
#undef          dtob
#undef          btod
#undef          btoa

#ifdef  SYSV
#include                <fcntl.h>
#endif

#include        "system.h"

#ifndef MAXPATHLEN
#define         MAXPATHLEN      1026            // For System V
#endif

#if     ZZ_ATT
extern "C" {
#ifdef  vax
int     getpagesize ();
#endif
char    *ctime (long*);
int     ftruncate (int, long);
}
#endif

#ifdef  mips
extern "C" {
void    *zz_getsp ();
void    zz_putsp (void*);
void    zz_longjmp (jmp_buf, int);
int     zz_setjmp (jmp_buf);
}
#endif

#ifndef ZZ_ATT
char    *ProtocolId;
#endif

static  void    checkpoint ();                  // Checkpoint signal service
static  void    restart ();                     // Checkpoint restart function

char            ofnambuf [MAXPATHLEN];          // Output filename buffer

static  struct  tms     etimes;

long                    times   ();

	// For properly calculating CPU execution time, also when smurph
	// is checkpointed
static  double          base_time,
			time_so_far = 0.0;

int                     FError;         // i/o error flag

static  int             ConMsg = NO;    // Console message flag

/* -------------------------------------- */
/* Signal servicing function (prototypes) */
/* -------------------------------------- */
static void  sigill (), sigfpx (), sigbus (), sigsegv (), sigint ();
#ifndef sgi
static void sigxcpu ();
#endif

/* ----------------------------- */
/* Page size (for checkpointing) */
/* ----------------------------- */
#ifdef  vax
static  int     page_size;
#endif

	// Note: non-standard memory allocator has been removed. Standard
	//       malloc will be used for the time being until I get around to
	//       program a new version

static  int     ecounter = 0;// Exception counter -- to avoid cascade exceptions

void    zz_closeMonitor ();

void    bad_arguments () {

/* ---------------------------------------------------------- */
/* Prints  info  about expected call arguments and aborts the */
/* program                                                    */
/* ---------------------------------------------------------- */

	cerr << "Usage:  " << *zz_callArgs << " 'options' 'files'\n";
	cerr << "    Options:\n";
	cerr << "     -r [n [n [n]]]  setting rnd seeds\n";
	cerr << "     -d              hang until display server connected\n";
	cerr << "     -t [n]          start tracing at n ITUs\n";
	cerr << "     -f              full tracing (together with -t)\n";
	cerr << "     -o              echo topology def to output file\n";
	cerr << "     -c              empty message queues\n";
	cerr << "     -u              disable standard client\n";
	cerr << "     -s              system event info to be exposed\n";
#if     ZZ_TOL
	cerr << "     -k t q          define clock tolerance and quality\n";
#endif
	cerr << "     -m              notify console about start/termination\n";
	cerr << "    Files: [inp [out]]\n";
	cerr << "     inp             input file (missing or . -> stdin)\n";
	cerr << "     out             output file (missing or . -> stdout)\n";
	cerr << "Usage:  " << *zz_callArgs << " -R chkpfile\n";
	cerr << "                     to restart from a checkpoint file\n";
	exit (21);
}

static void signal_service () {

/* ----------------------- */
/* Declares signal service */
/* ----------------------- */

	signal (SIGHUP , (SIGARG) sigint );
	signal (SIGILL , (SIGARG) sigill );
	signal (SIGIOT , (SIGARG) sigill );
	signal (SIGEMT , (SIGARG) sigill );
	signal (SIGSYS , (SIGARG) sigill );
	signal (SIGFPE , (SIGARG) sigfpx );
	signal (SIGBUS , (SIGARG) sigbus );
	signal (SIGSEGV, (SIGARG) sigsegv);
#ifndef sgi
	signal (SIGXCPU, (SIGARG) sigxcpu);
#endif
	if (signal (SIGINT, SIG_IGN) != SIG_IGN)
		signal (SIGINT, (SIGARG) sigint);
}

static void conMsg (char *t) {

/* ------------------------------- */
/* Writes a message to the console */
/* ------------------------------- */

	int     cfd;
	char    *st;

	if (!ConMsg) return;
	if ((cfd = open ("/dev/console", O_WRONLY, 0)) < 0) return;
	st = form ("\n%s: Smurph (PID = %1d) %s\n", tDate (), zz_processId, t);
	write (cfd, st, strlen (st));
	close (cfd);
}

static void outmes (ostream &fiptr, char *txt) {

/* --------------------- */
/* Outputs error message */
/* --------------------- */

	int     k;
	char    tc [47], *tcp;

	btoa (Time, tc, 46);
	for (tcp = tc; *tcp == ' '; tcp++);

	fiptr << ">>> " << txt << '\n';
	fiptr << ">>> At virtual time          = " << tcp << '\n';
	fiptr << ">>> Input data file name     = ";
	if ((zz_ifn == NULL) || ((zz_ifn[0] == '.') && (zz_ifn[1] == '\0')))
		fiptr << "STDIN";
	else
		fiptr << zz_ifn;
	fiptr << '\n';
	fiptr << ">>> Rnd initialization seeds = ";
	for (k=0; k < N_SEEDS; k++) fiptr << zz_OrgSeeds [k] << ' ';
	fiptr << '\n';
	zz_print_event_info (fiptr);
}

void    zz_ierror (char *t) {

/* ---------------------------------------------------------- */
/* Signals  a  fatal  error (that makes it impossible to even */
/* start the simulator) and aborts smurph                     */
/* ---------------------------------------------------------- */

	cerr << *zz_callArgs << ": " << t << '\n';
	conMsg ("aborted");
	exit (20);
}

static  void    fError (char*) {

/* ------------------------ */
/* Local file error handler */
/* ------------------------ */

	FError = YES;
}

void    zz_init_system  (int argc, char *argv []) {

/* ---------------------------------------------------------- */
/* Inteprets  parameters  from  the  call  line,  initializes */
/* things                                                     */
/* ---------------------------------------------------------- */

	int     i, k;
	long    l;

	zz_callArgs = argv;
	zz_callArgc = argc;

	set_File_error_handler (fError);

	Time = TIME_0;
	
#ifdef  vax
	// Get the page size (used by the checkpointer)
	if ((page_size = getpagesize ()) < 1) page_size = 1;
#endif
	zz_processId = getpid ();

	// Check for checkpoint restart

	if ((argc > 1) && (**(argv+1) == '-') && (*(*(argv+1) + 1) == 'R') &&
		(*(*(argv+1) + 2) == '\0')) {
		
		// Restart request

		argv += 2;      // Get to the checkpoint file name
		if (argc != 3)  // Exactly  2  parameters expected
			bad_arguments ();

		strcpy (ofnambuf, *argv);
		zz_ofn = ofnambuf;

		if ((zz_ofn [0] == '.') && (zz_ofn [1] == '\0')) {
			cerr <<
			 "Smurph restart: can't restart from standard output\n";
			exit (22);
		}
		
		signal (SIGCHKP, SIG_IGN);
		restart ();
	}

	// Get filenames and other call parameters

	for (argc--, argv++; argc;) {

		if (**argv != '-') {
			if (zz_ifn == NULL) {
				// Input file name
				zz_ifn = *argv;
			} else {
				if (zz_ofn == NULL) {
					// Output file name; copy it to the
					// auxiliary buffer for checkpointing.
					// Note that argv will be destroyed at
					// restart.

					strcpy (ofnambuf, *argv);
					zz_ofn = ofnambuf;

				} else {
					bad_arguments ();
				}
			}

			argv++;
			argc--;
			continue;
		}

		argc--;

		if ((*argv)[2] != '\0') bad_arguments ();

		switch ((*(argv++))[1]) {

			case 'r' : // Random seeds

				for (i = 0; argc; i++) {

					if ((**argv < '0') || (**argv > '9'))
						break;

					for (l = k = 0; ((*argv)[k] >= '0') &&
						((*argv)[k] <= '9'); k++)

						l = l * 10 + (*argv)[k] - '0';

					if ((*argv)[k] != '\0')
						bad_arguments ();

					if (i < N_SEEDS)
						zz_OrgSeeds [i] = l;

					argv++;
					argc--;
				}

				if (i == 0) bad_arguments ();

				break;

			// Note: remote simulation options have been deleted

			case 'd' : // Display

				zz_drequest = YES;
				break;

			// Note: the 'h' option has been removed. Halting
			// will be taken care of by the display server

			case 't' : // Tracing

				if (argc && (**argv >= '0') &&
					(**argv <= '9')) {

					for (k = 0, TracingTime = TIME_0;
						((*argv)[k] >= '0') &&
							((*argv)[k] <= '9');
								k++)

						TracingTime = TracingTime
						      * 10 + ((*argv)[k] - '0');

					if ((*argv)[k] != '\0')
						bad_arguments ();

					argv++;
					argc--;
				} else {
					TracingTime = TIME_0;
				}

				break;

			case 'f' : // Full trace (links dumped)

				if (undef (TracingTime)) bad_arguments ();
				FullTracing = YES;
				break;

			case 'o' : // Echo definitions to the output file

				zz_flg_printDefs = YES;
				break;

			case 'c' : // Empty message queues

				zz_flg_emptyMQueues = YES;
				break;

			case 'u' : // Do not start standard Client

				zz_flg_stdClient = NO;
				break;

			case 's' : // System event info to be exposed

				zz_flg_nosysdisp = NO;
				break;

#if     ZZ_TOL
			case 'k' : // Standard tolerance parameters

				if (argc < 2) bad_arguments ();
				zz_tolerance = atof (*argv);
				if (zz_tolerance < 0.0 || zz_tolerance > 1.0)
							       bad_arguments ();
				argv++;
				argc--;

				for (l = k = 0; ((*argv)[k] >= '0') &&
						((*argv)[k] <= '9'); k++)

					l = l * 10 + (*argv)[k] - '0';

				if ((*argv)[k] != '\0') bad_arguments ();
				zz_quality = (int) l;
				if (zz_quality < 0 || zz_quality > 10)
					bad_arguments ();
				break;
#endif
			case 'm' : // Console messages to be produced

				ConMsg = YES;
				break;

			default: bad_arguments ();
		}
	}

	// Initialize actual seeds
	for (i = 0; i < N_SEEDS; i++) {
#if     ZZ_R48
		zz_Seeds [i] [0] = (short) (zz_OrgSeeds [i] & 0177777);
		zz_Seeds [i] [1] = (short) ((zz_OrgSeeds [i] >> 16) & 0177777);
		zz_Seeds [i] [2] = zz_Seeds [i] [0];
#else
		zz_Seeds [i] = zz_OrgSeeds [i];
#endif
	}

	// Open input file

	if ((zz_ifn == NULL) || ((zz_ifn[0] == '.') && (zz_ifn[1] == '\0'))) {
		// Reading from standard input
		zz_ifpp = &cin;
	} else {
		FError = NO;
		zz_ifpp = new istream (zz_ifn, "r");
		if (FError) {
			zz_ifpp = NULL;
			ierror ("cannot open input file");
		}
	}

	// Output file

	if ((zz_ofn == NULL) || ((zz_ofn[0] == '.') && (zz_ofn[1] == '\0'))) {
		// Writing to standard output
		zz_ofpp = &cout;
	} else {
		FError = NO;
		i = umask (OMASK);
		zz_ofpp = new ostream (zz_ofn, "w");
		umask (i);
		if (FError) {
			zz_ofpp = NULL;
			ierror ("cannot open output file");
		}
	}

	// Declare signal service

	signal_service ();
	times (&etimes);
	base_time = (double) etimes.tms_utime / ZZ_HZ;

	/* ---------------------------- */
	/* Initialize for checkpointing */
	/* ---------------------------- */

	if ((zz_ofn == NULL) || ((zz_ofn[0] == '.') && (zz_ofn[1] == '\0')))

		// Checkpointing illegal

		signal (SIGCHKP, SIG_IGN);
	else
		signal (SIGCHKP, (SIGARG) checkpoint);
	conMsg ("started");
}

void    zz_done () {

/* -------------------------------- */
/* Actual unconditional termination */
/* -------------------------------- */

	if (DisplayActive) zz_dterminate ();
	if (zz_ofpp != NULL) {
		Ouf << "\n@@@ End of output\n";
		Ouf.flush ();
	}
	conMsg ("terminated");
	exit (0);
}

excptn  (char *sig) {

/* ---------------- */
/* Abort simulation */
/* ---------------- */

	if (zz_ofpp != NULL) Ouf.flush ();

	if (ecounter++ > 1) {
		// Avoid cascade errors
		conMsg ("aborted");
		exit (3);
	}
	if (DisplayActive) displayNote (form ("*%s", sig));

	signal (SIGTSTP, SIG_DFL);
	outmes (cerr, sig);
	if (zz_ofpp != NULL) {
		outmes (Ouf, sig);
		Ouf << '\n';
	}
	zz_exit_code = EXIT_abort;
	if (ecounter > 1) zz_done ();   // Do not return on second error
	// Set up the abort flag
	Kernel->terminate ();
	return (0);
}

/* ------------------------ */
/* Signal service functions */
/* ------------------------ */

static  void    sigill () {             // Service illegal instruction

	signal (SIGILL , SIG_DFL );
	signal (SIGIOT , SIG_DFL );
	signal (SIGEMT , SIG_DFL );
	signal (SIGSYS , SIG_DFL );
	excptn ("illegal machine instruction");
}

#if     ZZ_AER

zz_aerror (char *t) {

/* ------------------------------------ */
/* Print out arithmetic error diagnosis */
/* ------------------------------------ */

	return (excptn (form ("BIG arithmetic error: %s", t)));
}

#endif

static  void    sigfpx () {             // Service floating point exception

	signal (SIGFPE , SIG_DFL);
	excptn ("floating point exception");
}

static  void    sigbus () {             // Service bus error

	signal (SIGBUS , SIG_DFL);
	excptn ("bus error - take taxi");
}

static  void    sigsegv () {            // Service segmentation violation

	signal (SIGSEGV, SIG_DFL);
	excptn ("segmentation violation");
}

#ifndef sgi
static  void    sigxcpu () {            // CPU Time limit

	signal (SIGXCPU, SIG_DFL);
	excptn ("CPU Time limit");
}
#endif

static  void    sigint  () {            // User kill

	excptn ("Simulation aborted");
}

double  cpuTime () {

/* ------------------------------------------ */
/* Give the program execution time in seconds */
/* ------------------------------------------ */

	times (&etimes);
	return ((double) etimes.tms_utime / ZZ_HZ - base_time + time_so_far);
}

char    *tDate () {

/* ------------------------------------ */
/* Return date and time in textual form */
/* ------------------------------------ */

	long    atime;
	char    *ct, *wt;

	atime = time (0);
	for (wt = ct = ctime (&atime); *ct != '\0'; ct++)
		if (*ct == '\n') {
			*ct = '\0';
			break;
		}
	return (wt);
}

/* ---------------------- */
/* Code for checkpointing */
/* ---------------------- */

	// Variables for checkpoint (dynamic variables not allowed)

	static          char     *sp;            // The stack pointer
	static          char     *p;             // A generic pointer
#ifdef  sun
	static          jmp_buf  env;            // This  environment
#endif
#ifdef  mips
#ifdef  SYSV
	static          int      old_env [268];
#else
	static          jmp_buf  old_env;
#endif
#else
	static          jmp_buf  old_env;        // Saved environment
#endif
	static          int      fd;             // A file descriptor
	static          char     mg;             // One character buffer
	static volatile long     opos;           // Output file position

	static void wdata (), rdata ();

static  void    checkpoint () {

/* ------------------------- */
/* Checkpoint signal service */
/* ------------------------- */

	zz_chckint = 0;
}

void    zz_checkpoint () {

/* --------------------- */
/* Checkpoint processing */
/* --------------------- */

	// Note: we assume that DisplayActive is NO

	signal (SIGCHKP, SIG_IGN);
	conMsg ("swapping out");
	zz_closeMonitor ();

	// Execution time so far
	times (&etimes);
	time_so_far += ((double) etimes.tms_utime / ZZ_HZ - base_time);

	Ouf.close ();           // Close the output file
	delete (zz_ofpp);       // And deallocate it

#ifdef  mips
	if (zz_setjmp (old_env) == 0) {
#else
	if (setjmp (old_env) == 0) {
#endif
		// Continue checkpointing:
		// Re-open the output file - now the checkpoint file

		opos = umask (OMASK);
		if ((fd = open (zz_ofn, O_WRONLY|O_CREAT, 0666)) < 0) {
		      perror ("smurph chkp (unable to open chkp file)");
		      exit (23);
		}
		umask ((unsigned short)opos);

		// Bypass the partial results

		if (lseek (fd, 0L, L_XTND) < 0) {
			perror ("smurph chkp (unable to seek chkp file)");
			exit (23);
		}

		mg = CMAGIC;    // Follow by the magic byte
		if (write (fd, &mg, 1) < 1) {
CKP_UNBL:
		     perror ("smurph chkp (unable to write chkp file)");
		     exit (23);
		}

		// Save current environment

		sp = (char*) (old_env [CENVSP]);
		if (write (fd, RWCAST old_env, sizeof (old_env)) < 
			sizeof (old_env))
				goto CKP_UNBL;

		// Write the stack

		if (write (fd, sp-1, (USRSTACK-1)-((unsigned int) sp-1)+1) <
				(USRSTACK-1)-((unsigned int) sp-1)+1) 
					goto CKP_UNBL;
		// And data

		wdata ();
		exit (99);

		// That's it
	}

	// Continue restart - read the data area

	cdebug ("Before reading data\n");
	rdata ();
	cdebug ("After reading data\n");

	// Re-open the output file

	FError = NO;
	zz_ofpp = new ostream (zz_ofn, "a");
	if (FError) {
		perror ("smurph restart (can't re-open output file)");
		exit (22);
	}

	// Restore process id

	zz_processId = getpid ();

	// Re-initialize display

	cdebug ("Before init windows\n");
	zz_drequest = 0;
	zz_init_windows ();
	cdebug ("After init windows\n");

	// Re-declare signal service

	signal_service ();
	signal (SIGCHKP, (SIGARG) checkpoint);

	// Re-start counting time

	times (&etimes);
	base_time = (double) etimes.tms_utime / ZZ_HZ;
	conMsg ("resumed");
}

static void restart () {

/* ------------------ */
/* Checkpoint restart */
/* ------------------ */

	if ((fd = open (zz_ofn, O_RDWR)) < 0) {
		// Use raw UNIX interface
		perror ("smurph restart (opening chkp file)");
		exit (22);
	}

	// Look for the magic byte (-1) to skip the output file
	cdebug ("CHKP file opened\n");

	for (opos = 0; ; opos++) {
		if (read (fd, &mg, 1) <= 0) {

		// This may look inefficient, however, the output
		// file is very short at this moment.
CKP_CORR:
			perror ("smurph restart (chkp file corrupted)");
			exit (23);
		}
		if (mg == CMAGIC) break;
	}
	cdebug ("Magic byte found\n");

	// Read the saved context

	if (read (fd, RWCAST old_env, sizeof (old_env)) < sizeof (old_env))
		goto CKP_CORR;

	cdebug ("Old environment read\n");

	// Get the old stack pointer

	sp = (char*) (old_env [CENVSP]);
#ifndef sun
	// Get the current stack pointer by hand
#ifdef vax
	asm ("   movl  sp,_p");
#else
	p = (char*) zz_getsp ();        // For MIPS
#endif

#else
	if (setjmp (env) == 0) {
		p = (char *) env [CENVSP];
#endif
		// Make sure the stack is big enough

		for (; (unsigned) p > (unsigned) sp; *(--p) = (char) 1);

		// Restore stack pointer
#ifndef sun
#ifdef  vax
		asm ("   movl  _sp,sp");
#else
		zz_putsp (sp);  // For MIPS
#endif
#else
		env[CENVSP] = (int) sp;
		longjmp (env, 1);
	} else {
#endif
		// Return from the longjmp above - read the stack

		if (read (fd, sp-1, (USRSTACK-1) - ((unsigned int)sp-1) + 1) <
			(USRSTACK-1) - ((unsigned int)sp-1) + 1)
				goto CKP_CORR;
#ifndef sun
		// Restore frame pointer and argument pointer
#ifdef  vax
		sp = p;  // Does nothing (bypasses a bug in the compiler)
		asm ("   movl  _old_env+12,fp");
		asm ("   movl  _old_env+16,ap");
		longjmp (old_env, 1);
#else
		zz_longjmp (old_env, 1);        // For MIPS
#endif

#else
		longjmp (old_env, 1);
	}
#endif
}

#ifdef  vax
extern  etext;  // End of the text area (supplied by 'ld')
#endif

static void wdata () {

/* ------------------------------------------ */
/* Write the data area to the checkpoint file */
/* ------------------------------------------ */

	unsigned long   size,
			end,
			begin;

	// Determine the length of the data area

#ifdef  vax
	begin = (((int)(&etext) + page_size - 1)/page_size) * page_size;
#else
#ifdef  mips
	begin = USRDATA;
#else
struct exec     header;
	bcopy ((void*) USRTEXT, (void*) (&header), sizeof (struct exec));
	begin = N_DATADDR (header);
#endif
#endif
	end = (int) sbrk (0);
	size = end - begin - 1 + 1;

	if (write (fd, RWCAST &size, sizeof (unsigned long)) < 
		sizeof (unsigned long)) {
CKP_UNBL:
		perror ("smurph chkp (unable to write chkp file)");
		exit (23);
	}

	if (write (fd, RWCAST ((void*) begin), (unsigned int)size) < size)
		goto CKP_UNBL;
	if (close (fd) < 0) {
#ifdef  sgi
		// There seem to be some problems on sgi related to this
		// close operation. I couldn't really create a replicatable
		// environment to trace them.
		for (end = 0; end < 10; end++) if (close (fd) >= 0) exit (23);
#endif
		perror ("smurph chkp (unable to close chkp file)");
		exit (23);
	}
}

static void rdata () {

/* ------------------ */
/* Read the data area */
/* ------------------ */

	int             lfd;    // Local copy of fd (now global variables will
	unsigned long   begin,  // be overwritten.
			size;

	long            lopos;  // File position (a copy of opos)
	char            bb [MAXPATHLEN];

	// Determine the length of the data area
#ifdef  vax
	begin = (((int)(&etext) + page_size - 1)/page_size) * page_size;
#else
#ifdef  mips
	begin = USRDATA;
#else
struct exec     header;
	bcopy ((void*) USRTEXT, (void*) (&header), sizeof (struct exec));
	begin = N_DATADDR (header);
#endif
#endif
	lfd = fd;       // fd is going to be overwritten
	lopos = opos;   // Same with opos

	// Save the output file name on the stack

	strcpy (bb, zz_ofn);

	if (read (lfd, RWCAST &size, sizeof (unsigned long)) <
		sizeof (unsigned long)) {

		// Read the length of the data segment
CKP_CORR:
		perror ("smurph restart (chkp file corrupted)");
		exit (22);
	}

	if ((long) (sbrk ((int)size)) < 0) {

		// Allocate memory for the data segment

		perror ("smurph restart (no memory for data)");
		exit (22);
	}

	if (read (lfd, RWCAST ((void*) begin), (unsigned int) size) < size)
		goto CKP_CORR;

	// Truncate and close the output file

	if (ftruncate (lfd, lopos)) {
		perror ("smurph restart (can't truncate output file)");
		exit (22);
	}
	if (close (lfd)) {
		perror ("smurph restart (can't close checkpoint file)");
		exit (22);
	}

	// Restore output file name

	strcpy (ofnambuf, bb);
	zz_ofn = ofnambuf;
}
